function IrcClient(sockJs, nick, userName, realName) {
    this.sockJs = sockJs;
    this.nick = nick;
    this.userName = userName;
    this.realName = realName;

    this.sendMsg = function(msg) {
        console.log("OUT-MSG " + msg);
        this.sockJs.send(msg);
    };

    this.sendNickMsg = function() {
        this.sendMsg("NICK " + this.nick);
    };

    this.sendUserMsg = function() {
        this.sendMsg("USER " + this.userName + " 0 * :" + this.realName);
    };

    this.init = function () {
        this.sendNickMsg();
        this.sendUserMsg();
    };

    var ircClientRef = this;

    this.sockJs.onopen = function () {
        console.log("Socket opened");
        ircClientRef.init();
    };

    this.sockJs.onclose = function () {
        console.log("Socket closed");
    };

    this.sendPongMsg = function(nr) {
        this.sendMsg("PONG :" + nr);
    };

    this.handlePongMessage = function (payload, data) {
        console.log("PING message: " + data);
        this.sendPongMsg(data);
    };

    this.sockJs.onmessage = function (e) {
        console.log("Received message: " + e.data);
        var server = document.getElementById("server");
        var logRow = document.createElement("div");
        logRow.innerHTML = e.data;
        server.appendChild(logRow);
        if (e.data.startsWith("PING ")) {
            ircClientRef.handlePongMessage(e.data, e.data.substr(7));
        }
    };

};